const Chord = require('./chord');
const Pitch = require('./pitch');
const PitchClass = require('./pitch-class');
const RelativePitch = require('./relative-pitch');
const Scale = require('./scale');
/**
 * @module model
 * @description
 * #### Core model used to build melodies, bass lines, and harmonic patterns.
 * - {@link Chord}
 * - {@link Pitch}
 * - {@link PitchClass}
 * - {@link RelativePitch}
 * - {@link Scale}
 */
module.exports = { Chord, Pitch, PitchClass, RelativePitch, Scale };
