const Harmony = require('./harmony');
const Part = require('./part');
const Random = require('./random');
const Rhythm = require('./rhythm');
const Section = require('./section');
const Song = require('./song');
/**
 * @module structure
 * @description
 * #### Objects that produce musical patterns which can be played or saved to a MIDI file.
 * - {@link Harmony}
 * - {@link Part}
 * - {@link Random}
 * - {@link Rhythm}
 * - {@link Section}
 * - {@link Song}
 */
module.exports = { Harmony, Part, Random, Rhythm, Section, Song };
